<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0"><meta name="generator" content="rustdoc"><meta name="description" content="Source of the Rust file `&#x2F;nix&#x2F;store&#x2F;klw0pjcx3gcsqz561gi1wwv8hj1lg84w-vendored-sources&#x2F;itoa-1.0.1&#x2F;src&#x2F;lib.rs`."><meta name="keywords" content="rust, rustlang, rust-lang"><title>lib.rs - source</title><link rel="stylesheet" type="text/css" href="../../normalize.css"><link rel="stylesheet" type="text/css" href="../../rustdoc.css" id="mainThemeStyle"><link rel="stylesheet" type="text/css" href="../../light.css"  id="themeStyle"><link rel="stylesheet" type="text/css" href="../../dark.css" disabled ><link rel="stylesheet" type="text/css" href="../../ayu.css" disabled ><script id="default-settings" ></script><script src="../../storage.js"></script><script src="../../crates.js"></script><noscript><link rel="stylesheet" href="../../noscript.css"></noscript><link rel="alternate icon" type="image/png" href="../../favicon-16x16.png"><link rel="alternate icon" type="image/png" href="../../favicon-32x32.png"><link rel="icon" type="image/svg+xml" href="../../favicon.svg"><style type="text/css">#crate-search{background-image:url("../../down-arrow.svg");}</style></head><body class="rustdoc source"><!--[if lte IE 11]><div class="warning">This old browser is unsupported and will most likely display funky things.</div><![endif]--><nav class="sidebar"><div class="sidebar-menu" role="button">&#9776;</div><a href='../../itoa/index.html'><div class='logo-container rust-logo'><img src='../../rust-logo.png' alt='logo'></div></a></nav><div class="theme-picker"><button id="theme-picker" aria-label="Pick another theme!" aria-haspopup="menu" title="themes"><img width="18" height="18" alt="Pick another theme!" src="../../brush.svg"></button><div id="theme-choices" role="menu"></div></div><nav class="sub"><form class="search-form"><div class="search-container"><div><select id="crate-search"><option value="All crates">All crates</option></select><input class="search-input" name="search" disabled autocomplete="off" spellcheck="false" placeholder="Click or press ‘S’ to search, ‘?’ for more options…" type="search"></div><button type="button" id="help-button" title="help">?</button><a id="settings-menu" href="../../settings.html" title="settings"><img width="18" height="18" alt="Change settings" src="../../wheel.svg"></a></div></form></nav><section id="main" class="content"><div class="example-wrap"><pre class="line-numbers"><span id="1">  1</span>
<span id="2">  2</span>
<span id="3">  3</span>
<span id="4">  4</span>
<span id="5">  5</span>
<span id="6">  6</span>
<span id="7">  7</span>
<span id="8">  8</span>
<span id="9">  9</span>
<span id="10"> 10</span>
<span id="11"> 11</span>
<span id="12"> 12</span>
<span id="13"> 13</span>
<span id="14"> 14</span>
<span id="15"> 15</span>
<span id="16"> 16</span>
<span id="17"> 17</span>
<span id="18"> 18</span>
<span id="19"> 19</span>
<span id="20"> 20</span>
<span id="21"> 21</span>
<span id="22"> 22</span>
<span id="23"> 23</span>
<span id="24"> 24</span>
<span id="25"> 25</span>
<span id="26"> 26</span>
<span id="27"> 27</span>
<span id="28"> 28</span>
<span id="29"> 29</span>
<span id="30"> 30</span>
<span id="31"> 31</span>
<span id="32"> 32</span>
<span id="33"> 33</span>
<span id="34"> 34</span>
<span id="35"> 35</span>
<span id="36"> 36</span>
<span id="37"> 37</span>
<span id="38"> 38</span>
<span id="39"> 39</span>
<span id="40"> 40</span>
<span id="41"> 41</span>
<span id="42"> 42</span>
<span id="43"> 43</span>
<span id="44"> 44</span>
<span id="45"> 45</span>
<span id="46"> 46</span>
<span id="47"> 47</span>
<span id="48"> 48</span>
<span id="49"> 49</span>
<span id="50"> 50</span>
<span id="51"> 51</span>
<span id="52"> 52</span>
<span id="53"> 53</span>
<span id="54"> 54</span>
<span id="55"> 55</span>
<span id="56"> 56</span>
<span id="57"> 57</span>
<span id="58"> 58</span>
<span id="59"> 59</span>
<span id="60"> 60</span>
<span id="61"> 61</span>
<span id="62"> 62</span>
<span id="63"> 63</span>
<span id="64"> 64</span>
<span id="65"> 65</span>
<span id="66"> 66</span>
<span id="67"> 67</span>
<span id="68"> 68</span>
<span id="69"> 69</span>
<span id="70"> 70</span>
<span id="71"> 71</span>
<span id="72"> 72</span>
<span id="73"> 73</span>
<span id="74"> 74</span>
<span id="75"> 75</span>
<span id="76"> 76</span>
<span id="77"> 77</span>
<span id="78"> 78</span>
<span id="79"> 79</span>
<span id="80"> 80</span>
<span id="81"> 81</span>
<span id="82"> 82</span>
<span id="83"> 83</span>
<span id="84"> 84</span>
<span id="85"> 85</span>
<span id="86"> 86</span>
<span id="87"> 87</span>
<span id="88"> 88</span>
<span id="89"> 89</span>
<span id="90"> 90</span>
<span id="91"> 91</span>
<span id="92"> 92</span>
<span id="93"> 93</span>
<span id="94"> 94</span>
<span id="95"> 95</span>
<span id="96"> 96</span>
<span id="97"> 97</span>
<span id="98"> 98</span>
<span id="99"> 99</span>
<span id="100">100</span>
<span id="101">101</span>
<span id="102">102</span>
<span id="103">103</span>
<span id="104">104</span>
<span id="105">105</span>
<span id="106">106</span>
<span id="107">107</span>
<span id="108">108</span>
<span id="109">109</span>
<span id="110">110</span>
<span id="111">111</span>
<span id="112">112</span>
<span id="113">113</span>
<span id="114">114</span>
<span id="115">115</span>
<span id="116">116</span>
<span id="117">117</span>
<span id="118">118</span>
<span id="119">119</span>
<span id="120">120</span>
<span id="121">121</span>
<span id="122">122</span>
<span id="123">123</span>
<span id="124">124</span>
<span id="125">125</span>
<span id="126">126</span>
<span id="127">127</span>
<span id="128">128</span>
<span id="129">129</span>
<span id="130">130</span>
<span id="131">131</span>
<span id="132">132</span>
<span id="133">133</span>
<span id="134">134</span>
<span id="135">135</span>
<span id="136">136</span>
<span id="137">137</span>
<span id="138">138</span>
<span id="139">139</span>
<span id="140">140</span>
<span id="141">141</span>
<span id="142">142</span>
<span id="143">143</span>
<span id="144">144</span>
<span id="145">145</span>
<span id="146">146</span>
<span id="147">147</span>
<span id="148">148</span>
<span id="149">149</span>
<span id="150">150</span>
<span id="151">151</span>
<span id="152">152</span>
<span id="153">153</span>
<span id="154">154</span>
<span id="155">155</span>
<span id="156">156</span>
<span id="157">157</span>
<span id="158">158</span>
<span id="159">159</span>
<span id="160">160</span>
<span id="161">161</span>
<span id="162">162</span>
<span id="163">163</span>
<span id="164">164</span>
<span id="165">165</span>
<span id="166">166</span>
<span id="167">167</span>
<span id="168">168</span>
<span id="169">169</span>
<span id="170">170</span>
<span id="171">171</span>
<span id="172">172</span>
<span id="173">173</span>
<span id="174">174</span>
<span id="175">175</span>
<span id="176">176</span>
<span id="177">177</span>
<span id="178">178</span>
<span id="179">179</span>
<span id="180">180</span>
<span id="181">181</span>
<span id="182">182</span>
<span id="183">183</span>
<span id="184">184</span>
<span id="185">185</span>
<span id="186">186</span>
<span id="187">187</span>
<span id="188">188</span>
<span id="189">189</span>
<span id="190">190</span>
<span id="191">191</span>
<span id="192">192</span>
<span id="193">193</span>
<span id="194">194</span>
<span id="195">195</span>
<span id="196">196</span>
<span id="197">197</span>
<span id="198">198</span>
<span id="199">199</span>
<span id="200">200</span>
<span id="201">201</span>
<span id="202">202</span>
<span id="203">203</span>
<span id="204">204</span>
<span id="205">205</span>
<span id="206">206</span>
<span id="207">207</span>
<span id="208">208</span>
<span id="209">209</span>
<span id="210">210</span>
<span id="211">211</span>
<span id="212">212</span>
<span id="213">213</span>
<span id="214">214</span>
<span id="215">215</span>
<span id="216">216</span>
<span id="217">217</span>
<span id="218">218</span>
<span id="219">219</span>
<span id="220">220</span>
<span id="221">221</span>
<span id="222">222</span>
<span id="223">223</span>
<span id="224">224</span>
<span id="225">225</span>
<span id="226">226</span>
<span id="227">227</span>
<span id="228">228</span>
<span id="229">229</span>
<span id="230">230</span>
<span id="231">231</span>
<span id="232">232</span>
<span id="233">233</span>
<span id="234">234</span>
<span id="235">235</span>
<span id="236">236</span>
<span id="237">237</span>
<span id="238">238</span>
<span id="239">239</span>
<span id="240">240</span>
<span id="241">241</span>
<span id="242">242</span>
<span id="243">243</span>
<span id="244">244</span>
<span id="245">245</span>
<span id="246">246</span>
<span id="247">247</span>
<span id="248">248</span>
<span id="249">249</span>
<span id="250">250</span>
<span id="251">251</span>
<span id="252">252</span>
<span id="253">253</span>
<span id="254">254</span>
<span id="255">255</span>
<span id="256">256</span>
<span id="257">257</span>
<span id="258">258</span>
<span id="259">259</span>
<span id="260">260</span>
<span id="261">261</span>
<span id="262">262</span>
<span id="263">263</span>
<span id="264">264</span>
<span id="265">265</span>
<span id="266">266</span>
<span id="267">267</span>
<span id="268">268</span>
<span id="269">269</span>
<span id="270">270</span>
<span id="271">271</span>
<span id="272">272</span>
<span id="273">273</span>
<span id="274">274</span>
<span id="275">275</span>
<span id="276">276</span>
<span id="277">277</span>
<span id="278">278</span>
<span id="279">279</span>
<span id="280">280</span>
<span id="281">281</span>
<span id="282">282</span>
<span id="283">283</span>
<span id="284">284</span>
</pre><pre class="rust"><code><span class="doccomment">//! [![github]](https://github.com/dtolnay/itoa)&amp;ensp;[![crates-io]](https://crates.io/crates/itoa)&amp;ensp;[![docs-rs]](https://docs.rs/itoa)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [github]: https://img.shields.io/badge/github-8da0cb?style=for-the-badge&amp;labelColor=555555&amp;logo=github</span>
<span class="doccomment">//! [crates-io]: https://img.shields.io/badge/crates.io-fc8d62?style=for-the-badge&amp;labelColor=555555&amp;logo=rust</span>
<span class="doccomment">//! [docs-rs]: https://img.shields.io/badge/docs.rs-66c2a5?style=for-the-badge&amp;labelColor=555555&amp;logoColor=white&amp;logo=data:image/svg+xml;base64,PHN2ZyByb2xlPSJpbWciIHhtbG5zPSJodHRwOi8vd3d3LnczLm9yZy8yMDAwL3N2ZyIgdmlld0JveD0iMCAwIDUxMiA1MTIiPjxwYXRoIGZpbGw9IiNmNWY1ZjUiIGQ9Ik00ODguNiAyNTAuMkwzOTIgMjE0VjEwNS41YzAtMTUtOS4zLTI4LjQtMjMuNC0zMy43bC0xMDAtMzcuNWMtOC4xLTMuMS0xNy4xLTMuMS0yNS4zIDBsLTEwMCAzNy41Yy0xNC4xIDUuMy0yMy40IDE4LjctMjMuNCAzMy43VjIxNGwtOTYuNiAzNi4yQzkuMyAyNTUuNSAwIDI2OC45IDAgMjgzLjlWMzk0YzAgMTMuNiA3LjcgMjYuMSAxOS45IDMyLjJsMTAwIDUwYzEwLjEgNS4xIDIyLjEgNS4xIDMyLjIgMGwxMDMuOS01MiAxMDMuOSA1MmMxMC4xIDUuMSAyMi4xIDUuMSAzMi4yIDBsMTAwLTUwYzEyLjItNi4xIDE5LjktMTguNiAxOS45LTMyLjJWMjgzLjljMC0xNS05LjMtMjguNC0yMy40LTMzLjd6TTM1OCAyMTQuOGwtODUgMzEuOXYtNjguMmw4NS0zN3Y3My4zek0xNTQgMTA0LjFsMTAyLTM4LjIgMTAyIDM4LjJ2LjZsLTEwMiA0MS40LTEwMi00MS40di0uNnptODQgMjkxLjFsLTg1IDQyLjV2LTc5LjFsODUtMzguOHY3NS40em0wLTExMmwtMTAyIDQxLjQtMTAyLTQxLjR2LS42bDEwMi0zOC4yIDEwMiAzOC4ydi42em0yNDAgMTEybC04NSA0Mi41di03OS4xbDg1LTM4Ljh2NzUuNHptMC0xMTJsLTEwMiA0MS40LTEwMi00MS40di0uNmwxMDItMzguMiAxMDIgMzguMnYuNnoiPjwvcGF0aD48L3N2Zz4K</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! &lt;br&gt;</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! This crate provides a fast conversion of integer primitives to decimal</span>
<span class="doccomment">//! strings. The implementation comes straight from [libcore] but avoids the</span>
<span class="doccomment">//! performance penalty of going through [`core::fmt::Formatter`].</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! See also [`ryu`] for printing floating point primitives.</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! [libcore]: https://github.com/rust-lang/rust/blob/b8214dc6c6fc20d0a660fb5700dca9ebf51ebe89/src/libcore/fmt/num.rs#L201-L254</span>
<span class="doccomment">//! [`core::fmt::Formatter`]: https://doc.rust-lang.org/std/fmt/struct.Formatter.html</span>
<span class="doccomment">//! [`ryu`]: https://github.com/dtolnay/ryu</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Example</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//! fn main() {</span>
<span class="doccomment">//!     let mut buffer = itoa::Buffer::new();</span>
<span class="doccomment">//!     let printed = buffer.format(128u64);</span>
<span class="doccomment">//!     assert_eq!(printed, &quot;128&quot;);</span>
<span class="doccomment">//! }</span>
<span class="doccomment">//! ```</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! # Performance (lower is better)</span>
<span class="doccomment">//!</span>
<span class="doccomment">//! ![performance](https://raw.githubusercontent.com/dtolnay/itoa/master/performance.png)</span>

<span class="attribute">#![<span class="ident">doc</span>(<span class="ident">html_root_url</span> <span class="op">=</span> <span class="string">&quot;https://docs.rs/itoa/1.0.1&quot;</span>)]</span>
<span class="attribute">#![<span class="ident">no_std</span>]</span>
<span class="attribute">#![<span class="ident">allow</span>(
    <span class="ident">clippy::cast_lossless</span>,
    <span class="ident">clippy::cast_possible_truncation</span>,
    <span class="ident">clippy::must_use_candidate</span>,
    <span class="ident">clippy::unreadable_literal</span>
)]</span>

<span class="kw">mod</span> <span class="ident">udiv128</span>;

<span class="kw">use</span> <span class="ident">core::mem</span>::{<span class="self">self</span>, <span class="ident">MaybeUninit</span>};
<span class="kw">use</span> <span class="ident">core</span>::{<span class="ident">ptr</span>, <span class="ident">slice</span>, <span class="ident">str</span>};

<span class="doccomment">/// A correctly sized stack allocation for the formatted integer to be written</span>
<span class="doccomment">/// into.</span>
<span class="doccomment">///</span>
<span class="doccomment">/// # Example</span>
<span class="doccomment">///</span>
<span class="doccomment">/// ```</span>
<span class="doccomment">/// let mut buffer = itoa::Buffer::new();</span>
<span class="doccomment">/// let printed = buffer.format(1234);</span>
<span class="doccomment">/// assert_eq!(printed, &quot;1234&quot;);</span>
<span class="doccomment">/// ```</span>
<span class="kw">pub</span> <span class="kw">struct</span> <span class="ident">Buffer</span> {
    <span class="ident">bytes</span>: [<span class="ident">MaybeUninit</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>; <span class="ident">I128_MAX_LEN</span>],
}

<span class="kw">impl</span> <span class="ident">Default</span> <span class="kw">for</span> <span class="ident">Buffer</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">default</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Buffer</span> {
        <span class="ident">Buffer::new</span>()
    }
}

<span class="kw">impl</span> <span class="ident">Clone</span> <span class="kw">for</span> <span class="ident">Buffer</span> {
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">fn</span> <span class="ident">clone</span>(<span class="kw-2">&amp;</span><span class="self">self</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="self">Self</span> {
        <span class="ident">Buffer::new</span>()
    }
}

<span class="kw">impl</span> <span class="ident">Buffer</span> {
    <span class="doccomment">/// This is a cheap operation; you don&#39;t need to worry about reusing buffers</span>
    <span class="doccomment">/// for efficiency.</span>
    <span class="attribute">#[<span class="ident">inline</span>]</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">new</span>() <span class="op">-</span><span class="op">&gt;</span> <span class="ident">Buffer</span> {
        <span class="kw">let</span> <span class="ident">bytes</span> <span class="op">=</span> [<span class="ident">MaybeUninit</span>::<span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span><span class="ident">::uninit</span>(); <span class="ident">I128_MAX_LEN</span>];
        <span class="ident">Buffer</span> { <span class="ident">bytes</span> }
    }

    <span class="doccomment">/// Print an integer into this buffer and return a reference to its string</span>
    <span class="doccomment">/// representation within the buffer.</span>
    <span class="kw">pub</span> <span class="kw">fn</span> <span class="ident">format</span><span class="op">&lt;</span><span class="ident">I</span>: <span class="ident">Integer</span><span class="op">&gt;</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>, <span class="ident">i</span>: <span class="ident">I</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident">str</span> {
        <span class="ident">i</span>.<span class="ident">write</span>(<span class="kw">unsafe</span> {
            <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="kw-2">*</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="self">self</span>.<span class="ident">bytes</span> <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> [<span class="ident">MaybeUninit</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>; <span class="ident">I128_MAX_LEN</span>]
                <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="op">&lt;</span><span class="ident">I</span> <span class="kw">as</span> <span class="ident">private::Sealed</span><span class="op">&gt;</span><span class="ident">::Buffer</span>)
        })
    }
}

<span class="doccomment">/// An integer that can be written into an [`itoa::Buffer`][Buffer].</span>
<span class="doccomment">///</span>
<span class="doccomment">/// This trait is sealed and cannot be implemented for types outside of itoa.</span>
<span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Integer</span>: <span class="ident">private::Sealed</span> {}

<span class="comment">// Seal to prevent downstream implementations of the Integer trait.</span>
<span class="kw">mod</span> <span class="ident">private</span> {
    <span class="kw">pub</span> <span class="kw">trait</span> <span class="ident">Sealed</span>: <span class="ident">Copy</span> {
        <span class="kw">type</span> <span class="ident">Buffer</span>: <span class="lifetime">&#39;static</span>;
        <span class="kw">fn</span> <span class="ident">write</span>(<span class="self">self</span>, <span class="ident">buf</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="ident"><span class="self">Self</span>::Buffer</span>) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident">str</span>;
    }
}

<span class="kw">const</span> <span class="ident">DEC_DIGITS_LUT</span>: <span class="kw-2">&amp;</span>[<span class="ident">u8</span>] <span class="op">=</span> <span class="string">b&quot;\
      0001020304050607080910111213141516171819\
      2021222324252627282930313233343536373839\
      4041424344454647484950515253545556575859\
      6061626364656667686970717273747576777879\
      8081828384858687888990919293949596979899&quot;</span>;

<span class="comment">// Adaptation of the original implementation at</span>
<span class="comment">// https://github.com/rust-lang/rust/blob/b8214dc6c6fc20d0a660fb5700dca9ebf51ebe89/src/libcore/fmt/num.rs#L188-L266</span>
<span class="macro">macro_rules!</span> <span class="ident">impl_Integer</span> {
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">max_len</span>:<span class="ident">expr</span> <span class="op">=</span><span class="op">&gt;</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">t</span>:<span class="ident">ident</span>),<span class="op">*</span> <span class="kw">as</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">conv_fn</span>:<span class="ident">ident</span>) <span class="op">=</span><span class="op">&gt;</span> {$(
        <span class="kw">impl</span> <span class="ident">Integer</span> <span class="kw">for</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">t</span> {}

        <span class="kw">impl</span> <span class="ident">private::Sealed</span> <span class="kw">for</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">t</span> {
            <span class="kw">type</span> <span class="ident">Buffer</span> <span class="op">=</span> [<span class="ident">MaybeUninit</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">max_len</span>];

            <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_comparisons</span>)]</span>
            <span class="attribute">#[<span class="ident">inline</span>]</span>
            <span class="kw">fn</span> <span class="ident">write</span>(<span class="self">self</span>, <span class="ident">buf</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">MaybeUninit</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">max_len</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident">str</span> {
                <span class="kw">let</span> <span class="ident">is_nonnegative</span> <span class="op">=</span> <span class="self">self</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">0</span>;
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">n</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">is_nonnegative</span> {
                    <span class="self">self</span> <span class="kw">as</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">conv_fn</span>
                } <span class="kw">else</span> {
                    <span class="comment">// convert the negative num to positive by summing 1 to it&#39;s 2 complement</span>
                    (<span class="op">!</span>(<span class="self">self</span> <span class="kw">as</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">conv_fn</span>)).<span class="ident">wrapping_add</span>(<span class="number">1</span>)
                };
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">curr</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">isize</span>;
                <span class="kw">let</span> <span class="ident">buf_ptr</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">as_mut_ptr</span>() <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="ident">u8</span>;
                <span class="kw">let</span> <span class="ident">lut_ptr</span> <span class="op">=</span> <span class="ident">DEC_DIGITS_LUT</span>.<span class="ident">as_ptr</span>();

                <span class="kw">unsafe</span> {
                    <span class="comment">// need at least 16 bits for the 4-characters-at-a-time to work.</span>
                    <span class="kw">if</span> <span class="ident">mem::size_of</span>::<span class="op">&lt;</span><span class="macro-nonterminal">$</span><span class="macro-nonterminal">t</span><span class="op">&gt;</span>() <span class="op">&gt;</span><span class="op">=</span> <span class="number">2</span> {
                        <span class="comment">// eagerly decode 4 characters at a time</span>
                        <span class="kw">while</span> <span class="ident">n</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">10000</span> {
                            <span class="kw">let</span> <span class="ident">rem</span> <span class="op">=</span> (<span class="ident">n</span> <span class="op">%</span> <span class="number">10000</span>) <span class="kw">as</span> <span class="ident">isize</span>;
                            <span class="ident">n</span> <span class="op">/</span><span class="op">=</span> <span class="number">10000</span>;

                            <span class="kw">let</span> <span class="ident">d1</span> <span class="op">=</span> (<span class="ident">rem</span> <span class="op">/</span> <span class="number">100</span>) <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">1</span>;
                            <span class="kw">let</span> <span class="ident">d2</span> <span class="op">=</span> (<span class="ident">rem</span> <span class="op">%</span> <span class="number">100</span>) <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">1</span>;
                            <span class="ident">curr</span> <span class="op">-</span><span class="op">=</span> <span class="number">4</span>;
                            <span class="ident">ptr::copy_nonoverlapping</span>(<span class="ident">lut_ptr</span>.<span class="ident">offset</span>(<span class="ident">d1</span>), <span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span>), <span class="number">2</span>);
                            <span class="ident">ptr::copy_nonoverlapping</span>(<span class="ident">lut_ptr</span>.<span class="ident">offset</span>(<span class="ident">d2</span>), <span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span> <span class="op">+</span> <span class="number">2</span>), <span class="number">2</span>);
                        }
                    }

                    <span class="comment">// if we reach here numbers are &lt;= 9999, so at most 4 chars long</span>
                    <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">n</span> <span class="op">=</span> <span class="ident">n</span> <span class="kw">as</span> <span class="ident">isize</span>; <span class="comment">// possibly reduce 64bit math</span>

                    <span class="comment">// decode 2 more chars, if &gt; 2 chars</span>
                    <span class="kw">if</span> <span class="ident">n</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">100</span> {
                        <span class="kw">let</span> <span class="ident">d1</span> <span class="op">=</span> (<span class="ident">n</span> <span class="op">%</span> <span class="number">100</span>) <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">1</span>;
                        <span class="ident">n</span> <span class="op">/</span><span class="op">=</span> <span class="number">100</span>;
                        <span class="ident">curr</span> <span class="op">-</span><span class="op">=</span> <span class="number">2</span>;
                        <span class="ident">ptr::copy_nonoverlapping</span>(<span class="ident">lut_ptr</span>.<span class="ident">offset</span>(<span class="ident">d1</span>), <span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span>), <span class="number">2</span>);
                    }

                    <span class="comment">// decode last 1 or 2 chars</span>
                    <span class="kw">if</span> <span class="ident">n</span> <span class="op">&lt;</span> <span class="number">10</span> {
                        <span class="ident">curr</span> <span class="op">-</span><span class="op">=</span> <span class="number">1</span>;
                        <span class="kw-2">*</span><span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span>) <span class="op">=</span> (<span class="ident">n</span> <span class="kw">as</span> <span class="ident">u8</span>) <span class="op">+</span> <span class="string">b&#39;0&#39;</span>;
                    } <span class="kw">else</span> {
                        <span class="kw">let</span> <span class="ident">d1</span> <span class="op">=</span> <span class="ident">n</span> <span class="op">&lt;</span><span class="op">&lt;</span> <span class="number">1</span>;
                        <span class="ident">curr</span> <span class="op">-</span><span class="op">=</span> <span class="number">2</span>;
                        <span class="ident">ptr::copy_nonoverlapping</span>(<span class="ident">lut_ptr</span>.<span class="ident">offset</span>(<span class="ident">d1</span>), <span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span>), <span class="number">2</span>);
                    }

                    <span class="kw">if</span> <span class="op">!</span><span class="ident">is_nonnegative</span> {
                        <span class="ident">curr</span> <span class="op">-</span><span class="op">=</span> <span class="number">1</span>;
                        <span class="kw-2">*</span><span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span>) <span class="op">=</span> <span class="string">b&#39;-&#39;</span>;
                    }
                }

                <span class="kw">let</span> <span class="ident">len</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="ident">curr</span> <span class="kw">as</span> <span class="ident">usize</span>;
                <span class="kw">let</span> <span class="ident">bytes</span> <span class="op">=</span> <span class="kw">unsafe</span> { <span class="ident">slice::from_raw_parts</span>(<span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span>), <span class="ident">len</span>) };
                <span class="kw">unsafe</span> { <span class="ident">str::from_utf8_unchecked</span>(<span class="ident">bytes</span>) }
            }
        }
    )<span class="kw-2">*</span>};
}

<span class="kw">const</span> <span class="ident">I8_MAX_LEN</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">4</span>;
<span class="kw">const</span> <span class="ident">U8_MAX_LEN</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">3</span>;
<span class="kw">const</span> <span class="ident">I16_MAX_LEN</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">6</span>;
<span class="kw">const</span> <span class="ident">U16_MAX_LEN</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">5</span>;
<span class="kw">const</span> <span class="ident">I32_MAX_LEN</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">11</span>;
<span class="kw">const</span> <span class="ident">U32_MAX_LEN</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">10</span>;
<span class="kw">const</span> <span class="ident">I64_MAX_LEN</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">20</span>;
<span class="kw">const</span> <span class="ident">U64_MAX_LEN</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">20</span>;

<span class="macro">impl_Integer!</span>(
    <span class="ident">I8_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">i8</span>,
    <span class="ident">U8_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">u8</span>,
    <span class="ident">I16_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">i16</span>,
    <span class="ident">U16_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">u16</span>,
    <span class="ident">I32_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">i32</span>,
    <span class="ident">U32_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">u32</span>
    <span class="kw">as</span> <span class="ident">u32</span>);

<span class="macro">impl_Integer!</span>(<span class="ident">I64_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">i64</span>, <span class="ident">U64_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">u64</span> <span class="kw">as</span> <span class="ident">u64</span>);

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;16&quot;</span>)]</span>
<span class="macro">impl_Integer!</span>(<span class="ident">I16_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">isize</span>, <span class="ident">U16_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">usize</span> <span class="kw">as</span> <span class="ident">u16</span>);

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;32&quot;</span>)]</span>
<span class="macro">impl_Integer!</span>(<span class="ident">I32_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">isize</span>, <span class="ident">U32_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">usize</span> <span class="kw">as</span> <span class="ident">u32</span>);

<span class="attribute">#[<span class="ident">cfg</span>(<span class="ident">target_pointer_width</span> <span class="op">=</span> <span class="string">&quot;64&quot;</span>)]</span>
<span class="macro">impl_Integer!</span>(<span class="ident">I64_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">isize</span>, <span class="ident">U64_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">usize</span> <span class="kw">as</span> <span class="ident">u64</span>);

<span class="macro">macro_rules!</span> <span class="ident">impl_Integer128</span> {
    ($(<span class="macro-nonterminal">$</span><span class="macro-nonterminal">max_len</span>:<span class="ident">expr</span> <span class="op">=</span><span class="op">&gt;</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">t</span>:<span class="ident">ident</span>),<span class="kw-2">*</span>) <span class="op">=</span><span class="op">&gt;</span> {$(
        <span class="kw">impl</span> <span class="ident">Integer</span> <span class="kw">for</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">t</span> {}

        <span class="kw">impl</span> <span class="ident">private::Sealed</span> <span class="kw">for</span> <span class="macro-nonterminal">$</span><span class="macro-nonterminal">t</span> {
            <span class="kw">type</span> <span class="ident">Buffer</span> <span class="op">=</span> [<span class="ident">MaybeUninit</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">max_len</span>];

            <span class="attribute">#[<span class="ident">allow</span>(<span class="ident">unused_comparisons</span>)]</span>
            <span class="attribute">#[<span class="ident">inline</span>]</span>
            <span class="kw">fn</span> <span class="ident">write</span>(<span class="self">self</span>, <span class="ident">buf</span>: <span class="kw-2">&amp;</span><span class="kw-2">mut</span> [<span class="ident">MaybeUninit</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>; <span class="macro-nonterminal">$</span><span class="macro-nonterminal">max_len</span>]) <span class="op">-</span><span class="op">&gt;</span> <span class="kw-2">&amp;</span><span class="ident">str</span> {
                <span class="kw">let</span> <span class="ident">is_nonnegative</span> <span class="op">=</span> <span class="self">self</span> <span class="op">&gt;</span><span class="op">=</span> <span class="number">0</span>;
                <span class="kw">let</span> <span class="ident">n</span> <span class="op">=</span> <span class="kw">if</span> <span class="ident">is_nonnegative</span> {
                    <span class="self">self</span> <span class="kw">as</span> <span class="ident">u128</span>
                } <span class="kw">else</span> {
                    <span class="comment">// convert the negative num to positive by summing 1 to it&#39;s 2 complement</span>
                    (<span class="op">!</span>(<span class="self">self</span> <span class="kw">as</span> <span class="ident">u128</span>)).<span class="ident">wrapping_add</span>(<span class="number">1</span>)
                };
                <span class="kw">let</span> <span class="kw-2">mut</span> <span class="ident">curr</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">isize</span>;
                <span class="kw">let</span> <span class="ident">buf_ptr</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">as_mut_ptr</span>() <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> <span class="ident">u8</span>;

                <span class="kw">unsafe</span> {
                    <span class="comment">// Divide by 10^19 which is the highest power less than 2^64.</span>
                    <span class="kw">let</span> (<span class="ident">n</span>, <span class="ident">rem</span>) <span class="op">=</span> <span class="ident">udiv128::udivmod_1e19</span>(<span class="ident">n</span>);
                    <span class="kw">let</span> <span class="ident">buf1</span> <span class="op">=</span> <span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span> <span class="op">-</span> <span class="ident">U64_MAX_LEN</span> <span class="kw">as</span> <span class="ident">isize</span>) <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> [<span class="ident">MaybeUninit</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>; <span class="ident">U64_MAX_LEN</span>];
                    <span class="ident">curr</span> <span class="op">-</span><span class="op">=</span> <span class="ident">rem</span>.<span class="ident">write</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="kw-2">*</span><span class="ident">buf1</span>).<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">isize</span>;

                    <span class="kw">if</span> <span class="ident">n</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> {
                        <span class="comment">// Memset the base10 leading zeros of rem.</span>
                        <span class="kw">let</span> <span class="ident">target</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">isize</span> <span class="op">-</span> <span class="number">19</span>;
                        <span class="ident">ptr::write_bytes</span>(<span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">target</span>), <span class="string">b&#39;0&#39;</span>, (<span class="ident">curr</span> <span class="op">-</span> <span class="ident">target</span>) <span class="kw">as</span> <span class="ident">usize</span>);
                        <span class="ident">curr</span> <span class="op">=</span> <span class="ident">target</span>;

                        <span class="comment">// Divide by 10^19 again.</span>
                        <span class="kw">let</span> (<span class="ident">n</span>, <span class="ident">rem</span>) <span class="op">=</span> <span class="ident">udiv128::udivmod_1e19</span>(<span class="ident">n</span>);
                        <span class="kw">let</span> <span class="ident">buf2</span> <span class="op">=</span> <span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span> <span class="op">-</span> <span class="ident">U64_MAX_LEN</span> <span class="kw">as</span> <span class="ident">isize</span>) <span class="kw">as</span> <span class="kw-2">*</span><span class="kw-2">mut</span> [<span class="ident">MaybeUninit</span><span class="op">&lt;</span><span class="ident">u8</span><span class="op">&gt;</span>; <span class="ident">U64_MAX_LEN</span>];
                        <span class="ident">curr</span> <span class="op">-</span><span class="op">=</span> <span class="ident">rem</span>.<span class="ident">write</span>(<span class="kw-2">&amp;</span><span class="kw-2">mut</span> <span class="kw-2">*</span><span class="ident">buf2</span>).<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">isize</span>;

                        <span class="kw">if</span> <span class="ident">n</span> <span class="op">!</span><span class="op">=</span> <span class="number">0</span> {
                            <span class="comment">// Memset the leading zeros.</span>
                            <span class="kw">let</span> <span class="ident">target</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">len</span>() <span class="kw">as</span> <span class="ident">isize</span> <span class="op">-</span> <span class="number">38</span>;
                            <span class="ident">ptr::write_bytes</span>(<span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">target</span>), <span class="string">b&#39;0&#39;</span>, (<span class="ident">curr</span> <span class="op">-</span> <span class="ident">target</span>) <span class="kw">as</span> <span class="ident">usize</span>);
                            <span class="ident">curr</span> <span class="op">=</span> <span class="ident">target</span>;

                            <span class="comment">// There is at most one digit left</span>
                            <span class="comment">// because u128::max / 10^19 / 10^19 is 3.</span>
                            <span class="ident">curr</span> <span class="op">-</span><span class="op">=</span> <span class="number">1</span>;
                            <span class="kw-2">*</span><span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span>) <span class="op">=</span> (<span class="ident">n</span> <span class="kw">as</span> <span class="ident">u8</span>) <span class="op">+</span> <span class="string">b&#39;0&#39;</span>;
                        }
                    }

                    <span class="kw">if</span> <span class="op">!</span><span class="ident">is_nonnegative</span> {
                        <span class="ident">curr</span> <span class="op">-</span><span class="op">=</span> <span class="number">1</span>;
                        <span class="kw-2">*</span><span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span>) <span class="op">=</span> <span class="string">b&#39;-&#39;</span>;
                    }

                    <span class="kw">let</span> <span class="ident">len</span> <span class="op">=</span> <span class="ident">buf</span>.<span class="ident">len</span>() <span class="op">-</span> <span class="ident">curr</span> <span class="kw">as</span> <span class="ident">usize</span>;
                    <span class="kw">let</span> <span class="ident">bytes</span> <span class="op">=</span> <span class="ident">slice::from_raw_parts</span>(<span class="ident">buf_ptr</span>.<span class="ident">offset</span>(<span class="ident">curr</span>), <span class="ident">len</span>);
                    <span class="ident">str::from_utf8_unchecked</span>(<span class="ident">bytes</span>)
                }
            }
        }
    )<span class="kw-2">*</span>};
}

<span class="kw">const</span> <span class="ident">U128_MAX_LEN</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">39</span>;
<span class="kw">const</span> <span class="ident">I128_MAX_LEN</span>: <span class="ident">usize</span> <span class="op">=</span> <span class="number">40</span>;

<span class="macro">impl_Integer128!</span>(<span class="ident">I128_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">i128</span>, <span class="ident">U128_MAX_LEN</span> <span class="op">=</span><span class="op">&gt;</span> <span class="ident">u128</span>);
</code></pre></div>
</section><section id="search" class="content hidden"></section><div id="rustdoc-vars" data-root-path="../../" data-current-crate="itoa" data-search-index-js="../../search-index.js" data-search-js="../../search.js"></div>
    <script src="../../main.js"></script><script src="../../source-script.js"></script><script src="../../source-files.js"></script>
</body></html>